"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var grpc = require("@grpc/grpc-js");
var protoLoader = require("@grpc/proto-loader/");
var slogger_proxy_1 = require("../browser/slogger-proxy");
var inversify_1 = require("inversify");
var slogger_1 = require("../common/slogger");
var PROTO_PATH = __dirname + '/../../../backend/slogger-service/slogger_service_api/proto/slogger_service.proto';
var SloggerElectronProxy = /** @class */ (function (_super) {
    __extends(SloggerElectronProxy, _super);
    function SloggerElectronProxy() {
        var _this = _super.call(this) || this;
        _this.SloggerService = _this.loadProtofile().SLoggerService;
        return _this;
    }
    SloggerElectronProxy.prototype.importFile = function (proto) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.importFile", {});
        var client = this.createClient();
        var self = this;
        var promise = new Promise(function (resolve, reject) {
            client.importFile(proto, function (error, response) {
                if (error) {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.importFile", { error: error.message });
                    reject(new Error(error.message));
                }
                else {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Response, "slogger-service.importFile", response);
                    resolve(response);
                }
                client.close();
            });
        });
        return promise;
    };
    SloggerElectronProxy.prototype.getDistinctFields = function (proto) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.getDistinctFields", proto);
        var client = this.createClient();
        var self = this;
        var promise = new Promise(function (resolve, reject) {
            client.getDistinctFields(proto, function (error, response) {
                if (error) {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.getDistinctFields", { error: error.message });
                    reject(new Error(error.message));
                }
                else {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Response, "slogger-service.getDistinctFields", response);
                    resolve(response);
                }
                client.close();
            });
        });
        return promise;
    };
    SloggerElectronProxy.prototype.clearData = function (proto) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.clearData", proto);
        var client = this.createClient();
        var self = this;
        var promise = new Promise(function (resolve, reject) {
            client.clearData(proto, function (error, response) {
                if (error) {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.clearData", { error: error.message });
                    reject(new Error(error.message));
                }
                else {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Response, "slogger-service.clearData", response);
                    resolve(response);
                }
                client.close();
            });
        });
        return promise;
    };
    SloggerElectronProxy.prototype.changeQuery = function (proto) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.changeQuery", proto);
        var client = this.createClient();
        var self = this;
        var promise = new Promise(function (resolve, reject) {
            client.changeQuery(proto, function (error, response) {
                if (error) {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.changeQuery", { error: error.message });
                    reject(new Error(error.message));
                }
                else {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Response, "slogger-service.changeQuery", response);
                    resolve(response);
                }
                client.close();
            });
        });
        return promise;
    };
    SloggerElectronProxy.prototype.getEventsFromTo = function (proto) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.getEventsFromTo", proto);
        var client = this.createClient();
        var self = this;
        var promise = new Promise(function (resolve, reject) {
            client.getEventsFromTo(proto, function (error, response) {
                if (error) {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.getEventsFromTo", { error: error.message });
                    reject(new Error(error.message));
                }
                else {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Response, "slogger-service.getEventsFromTo", { size: response.events.length });
                    resolve(response);
                }
                client.close();
            });
        });
        return promise;
    };
    SloggerElectronProxy.prototype.unregisterOnQueryChanged = function (proto) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.unregisterOnQueryChanged", proto);
        var client = this.createClient();
        var self = this;
        var promise = new Promise(function (resolve, reject) {
            client.unregisterOnQueryChanged(proto, function (error, response) {
                if (error) {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.unregisterOnQueryChanged", { error: error.message });
                    reject(new Error(error.message));
                }
                else {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Response, "slogger-service.unregisterOnQueryChanged", response);
                    resolve(response);
                }
                client.close();
            });
        });
        return promise;
    };
    SloggerElectronProxy.prototype.registerOnQueryChanged = function (proto, callback) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.registerOnQueryChanged", proto);
        var client = this.createClient();
        var call = client.registerOnQueryChanged(proto);
        var self = this;
        call.on('data', function (notification) {
            self.logger.logIpcCall(0, slogger_1.IpcMessageType.Notification, "slogger-service.registerOnQueryChanged", notification);
            callback(notification.resultSize);
        });
        call.on('error', function (error) {
            self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.registerOnQueryChanged", { error: error.message });
            callback(new Error(error.message));
            client.close();
        });
        call.on('end', function () {
            self.logger.logIpcCall(0, slogger_1.IpcMessageType.Notification, "slogger-service.registerOnQueryChanged", "STOPPED");
            client.close();
        });
    };
    SloggerElectronProxy.prototype.unregisterOnImportFile = function (proto) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.unregisterOnImportFile", proto);
        var client = this.createClient();
        var self = this;
        var promise = new Promise(function (resolve, reject) {
            client.unregisterOnImportFile(proto, function (error, response) {
                if (error) {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.unregisterOnImportFile", { error: error.message });
                    reject(new Error(error.message));
                }
                else {
                    self.logger.logIpcCall(0, slogger_1.IpcMessageType.Response, "slogger-service.unregisterOnImportFile", response);
                    resolve(response);
                }
                client.close();
            });
        });
        return promise;
    };
    SloggerElectronProxy.prototype.registerOnImportFile = function (proto, callback) {
        this.logger.logIpcCall(0, slogger_1.IpcMessageType.Request, "slogger-service.registerOnImportFile", proto);
        var client = this.createClient();
        var call = client.registerOnImportFile(proto);
        var self = this;
        call.on('data', function (notification) {
            self.logger.logIpcCall(0, slogger_1.IpcMessageType.Notification, "slogger-service.registerOnImportFile", notification);
            callback(notification);
        });
        call.on('error', function (error) {
            self.logger.logIpcCall(0, slogger_1.IpcMessageType.Error, "slogger-service.registerOnImportFile", { error: error.message });
            callback(new Error(error.message));
            client.close();
        });
        call.on('end', function () {
            self.logger.logIpcCall(0, slogger_1.IpcMessageType.Notification, "slogger-service.registerOnImportFile", "STOPPED");
            client.close();
        });
    };
    SloggerElectronProxy.prototype.loadProtofile = function () {
        console.info("Load protobuf file from " + PROTO_PATH);
        var packageDefinition = protoLoader.loadSync(PROTO_PATH, { keepCase: true,
            longs: String,
            enums: String,
            defaults: true,
            oneofs: true
        });
        return grpc.loadPackageDefinition(packageDefinition);
    };
    SloggerElectronProxy.prototype.createClient = function () {
        return new this.SloggerService('localhost:50051', grpc.credentials.createInsecure());
    };
    __decorate([
        inversify_1.inject(slogger_1.Slogger),
        __metadata("design:type", Object)
    ], SloggerElectronProxy.prototype, "logger", void 0);
    SloggerElectronProxy = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [])
    ], SloggerElectronProxy);
    return SloggerElectronProxy;
}(slogger_proxy_1.SloggerProxyDefault));
exports.SloggerElectronProxy = SloggerElectronProxy;
//# sourceMappingURL=slogger-electron-proxy.js.map