import { injectable } from "inversify";

export const SloggerProxy = Symbol('SloggerProxy');

export interface SloggerProxy {

    importFile(proto: any): Promise<unknown> ;

    changeQuery(proto: any): Promise<unknown> ;

    clearData(proto: any): Promise<unknown> ;

    registerOnQueryChanged(proto: any, callback: any) : any;

    unregisterOnQueryChanged(proto: any): Promise<unknown> ;

    getEventsFromTo(proto: any): Promise<unknown>;

    getDistinctFields(proto: any): Promise<unknown>;

    registerOnImportFile(proto: any, callback: any) : any;

    unregisterOnImportFile(proto: any): Promise<unknown> ;

}

@injectable()
export class SloggerProxyDefault implements SloggerProxy {

    registerOnImportFile(proto: any, callback: any) {
        callback("No implementation for registerOnImportFile", null);
    }
    
    unregisterOnImportFile(proto: any): Promise<unknown> {
        return new Promise( function (resolve, reject) {
            reject("No implementation for unregisterOnImportFile");
        });        
    }

    unregisterOnQueryChanged(proto: any): Promise<unknown> {
        return new Promise( function (resolve, reject) {
            reject("No implementation for unregisterOnQueryChanged");
        });        
    }
    
    getEventsFromTo(proto: any): Promise<unknown> {
        return new Promise( function (resolve, reject) {
            reject("No implementation for getEventsFromTo");
        });        
    }
    
    importFile (proto: any) {
        return new Promise( function (resolve, reject) {
            reject("No implementation for importDltFile");
        });        
    }

    clearData (proto: any) {
        return new Promise( function (resolve, reject) {
            reject("No implementation for clearData");
        });        
    }

    changeQuery(proto: any) {
        return new Promise( function (resolve, reject) {
            reject("No implementation for changeQuery");
        });        
    }
    
    getDistinctFields(proto: any) {
        return new Promise( function (resolve, reject) {
            reject("No implementation for getDistinctFields");
        });        
    }
    
    getEvents(proto: any) {
        return new Promise( function (resolve, reject) {
            reject("No implementation for getEvents");
        });        
    }

    registerOnQueryChanged(proto: any, callback: any) {
        callback("No implementation for registerOnQueryChanged", null);
    }


}